# coding: shift_jis
# [DeepLeraning2@ǉύX
# https://github.com/oreilly-japan/deep-learning-from-scratch-2
#  LRNN   nf[^̊wK@SIN֐@ڂȂ
# coding: utf-8
import pickle
import sys
import os
sys.path.append('..')
from common.optimizer import SGD
from common.optimizer import Adam
#from common.trainer import RnnlmTrainer
from common.trainer import remove_duplicate
from common.util import eval_perplexity,clip_grads
#from dataset import ptb
#from ch06.rnnlm import Rnnlm
import numpy as np
import numpy 
import time 
from common.time_layers import *
from common.base_model import BaseModel
from common.util import to_gpu, to_cpu
# @̓f[^2@-----------
class RnnlmTrainer:
    def __init__(self, model, optimizer):
        self.model = model
        self.optimizer = optimizer
        self.time_idx = None
        self.ppl_list = None
        self.eval_interval = None
        self.current_epoch = 0
    def get_batch(self, x, t, batch_size, time_size):
        batch_xa = np.empty((batch_size, time_size))
        batch_ta = np.empty((batch_size, time_size))
        data_size = len(x)
        jump = data_size // batch_size
        offsets = [i * jump for i in range(batch_size)]  # ob`̊eTv̓ǂݍ݊Jnʒu
        for time in range(time_size):
            for i, offset in enumerate(offsets):
                batch_xa[i] = x[(offset + self.time_idx) % data_size]
                batch_ta[i] = t[(offset + self.time_idx) % data_size]
            batch_x =batch_xa.reshape(batch_size,time_size,1)            
            batch_t =batch_ta.reshape(batch_size,time_size,1)
            self.time_idx += 1
        return batch_x, batch_t
    def fit(self, xs, ts, max_epoch=10, batch_size=20, time_size=35,
            max_grad=None, eval_interval=20):
        data_size = len(xs)
        max_iters = data_size // (batch_size)# * time_size)
        self.time_idx = 0
        self.ppl_list = []
        self.eval_interval = eval_interval
        model, optimizer = self.model, self.optimizer
        total_loss = 0
        loss_count = 0
        start_time = time.time()
        for epoch in range(max_epoch):
            total_loss = 0
            loss_count = 0
            #_\[g
            order = np.arange(xs.shape[0])
            np.random.shuffle(order)
            xs=xs[order]
            ts=ts[order]
            for iters in range(max_iters):
                batch_x, batch_t = self.get_batch(xs, ts, batch_size, time_size)
                # z߁Ap[^XV
                loss = model.forward(batch_x, batch_t)
                model.backward(loss)
#                params, grads = remove_duplicate(model.params, model.grads)  # Lꂽd݂1ɏW
                params, grads = model.params, model.grads  # Lꂽd݂1ɏW
#                if max_grad is not None:
#                    clip_grads(grads, max_grad)
                optimizer.update(params, grads)
                total_loss += sum((loss*loss/batch_size/batch_size).flatten())
                loss_count += 1
            ppl = np.exp(total_loss / loss_count)
            elapsed_time = time.time() - start_time
            print('| epoch %d |  iter %d / %d | time %d[s] | perplexity %.2f'
                    % (self.current_epoch + 1, iters + 1, max_iters, elapsed_time, ppl))
            self.ppl_list.append(float(ppl))
            total_loss, loss_count = 0, 0
            self.current_epoch += 1
    def plot(self, ylim=None):
        x = numpy.arange(len(self.ppl_list))
        if ylim is not None:
            plt.ylim(*ylim)
        plt.plot(x, self.ppl_list, label='train')
        plt.xlabel('iterations (x' + str(self.eval_interval) + ')')
        plt.ylabel('perplexity')
        plt.show()
#@@͑wTimeAffineɁ@W1@ lossvZ--- ----
class Rnnlm(BaseModel):
    def __init__(self, vocab_size=10000, wordvec_size=100, hidden_size=100):
        V, D, H = vocab_size, wordvec_size, hidden_size
        rn = np.random.randn
        # d݂̏
        affine_W1 = (rn(1, V) / np.sqrt(H)).astype('f')
        affine_b1 = np.zeros(V).astype('f')
        lstm_Wx = (rn(D, 4 * H) / np.sqrt(D)).astype('f')
        lstm_Wh = (rn(H, 4 * H) / np.sqrt(H)).astype('f')
        lstm_b = np.zeros(4 * H).astype('f')
        affine_W3 = (rn(H, 1) / np.sqrt(H)).astype('f')
        affine_b3 = np.zeros(1).astype('f')
        # C̐
        self.layers = [
            TimeAffine(affine_W1, affine_b1),
            TimeLSTM(lstm_Wx, lstm_Wh, lstm_b, stateful=False),
            TimeAffine(affine_W3, affine_b3)
        ]
#        self.loss_layer = TimeSoftmaxWithLoss()
#        self.lstm_layer = self.layers[1]
        # ׂĂ̏d݂ƌzXgɂ܂Ƃ߂
        self.params, self.grads = [], []
        for layer in self.layers:
            self.params += layer.params
            self.grads += layer.grads
    def predict(self, xs):
        for layer in self.layers:
            xs = layer.forward(xs)
        return xs
    def forward(self, xs, ts):
        score = self.predict(xs)
        loss =score- ts #self.loss_layer.forward(score, ts)
        return loss
    def backward(self, dout=1):
#        dout = self.loss_layer.backward(dout)
        for layer in reversed(self.layers):
            dout = layer.backward(dout)
        return dout
    def reset_state(self):
        self.lstm_layer.reset_state()
#---- zeLXgo---ǉ----------
def outh(h, ndimz):
    da = ""
    for j in np.arange(ndimz - 2):
        da = da + str(int(h[j])) + ","
    return da
def hup(mh, h, ndimz):
    up = -1  #オȂ
    #For j = ndim - 1 To 0 Step -1
    for j in np.arange(ndimz-1,-1,-1):
        h[j] = h[j] + 1
        if h[j] > mh[j] - 1:
            h[j] = 0
            up = j #ŌɌオ肵 0ŏI
            #print("up j="+ str(j)+" "+ str(up))  
        else:
            #print("break j="+ str(j)+" "+ str(up))  
            break
    return up    
def ich(mh, h, ndim, xh):
    dat = 0
    for j in np.arange(ndim - 1,-1,-1):
        dat = dat + h[j] * xh[j]
        if j > 0 :
            xh[j - 1] = xh[j] * mh[j]
    return dat
def shapem(a):
    if type(a) is numpy.ndarray :
        
        ds=""
        for i in range(a.ndim):
            ds=ds + str(a.shape[i])+','
    else:
        ds=""
    return ds
def dfile(path_w,com,dat):
#    return
    ms=shapem(dat)
    if ms=="" :
        with open(path_w, mode='a') as f:
            f.write(com+'(l'+str(dat)+')\n') 
    else:  
        ndimz=dat.ndim
        mh=np.zeros(ndimz)
        for i in np.arange(ndimz):
            mh[i]=dat.shape[i]
        h=np.zeros(ndimz)
        xh=np.zeros(ndimz)
        xh[ndimz - 1]=1
        up=-1
        pr=""
        dd=dat.flatten()
        with open(path_w, mode='a') as f:
            f.write(com+'('+ms+')\n') 
            while up !=0:
                jj=int(ich(mh, h, ndimz, xh))
                #print("jj="+ str(jj))
                pr=pr + " " + str(dd[jj])
                up=hup(mh, h, ndimz) #up=ndim-1 1ups  ̑  z\
                if up >= 0 : #up == ndim - 1:
                    f.write(pr+'\n')
                    pr=""
                    if up<ndimz - 1 and up!=0 :
                        f.write(  ' <<' + outh(h, ndimz)+'\n')    
# ---f[^Zbg̓ǂݍ-ύX@----
#  x Ɓ@t  ́@|@؂@f[^ ,؂
#  @@1,2,3,4|2,3,4,5
with open("RNNT.TXT") as f:
    data= f.readlines()
    t_train=[]
    x_train=[]
    for i,da in enumerate(data):
        idx = da.find('|')
        x_train.append(list(da[0:idx].split(",")))
        t_train.append(list(da[idx+1:-1].split(",")))
t_train=np.array(t_train)#[:,0:2]
x_train=np.array(x_train)#[:,0:2]
trken=len(x_train) # int(len(x_train)*0.8)  #80%PɎgp̏ꍇ
#print(x_train.shape)
#print(t_train.shape)
xs=x_train[0:trken]
ts=t_train[0:trken]
#x_test=x_train[trken:-1]
#t_test=t_train[trken:-1]
#-------------------------------
# nCp[p[^̐ݒ
batch_size = 1  #ob`@܂Ƃ߂ď邩
vocab_size =50
wordvec_size = 50
hidden_size = 100  # RNN̉BԃxNg̗vf
time_size = 10  # RNNWJTCY
lr=0.01 #wKW
max_epoch = 10 #P
max_grad =None
# f̐
model = Rnnlm(vocab_size, wordvec_size, hidden_size)
optimizer = SGD(lr)
#optimizer = Adam(lr)
#   Õp[^gpȂꍇ̓Rgɂ
#    model.load_params()
#for i,dat in enumerate(model.params):
#    dfile(fpara,'i',i)
#    dfile(fpara,'params',dat)
#-----------------------------------------------
trainer = RnnlmTrainer(model, optimizer)
print("Jn")
# zNbsOgpŊwK
trainer.fit(xs, ts, max_epoch, batch_size, time_size, max_grad,
            eval_interval=20)
#  p[^ۑ
#model.save_params()
#  ----o[^eLXgo ---ǉ@----------------
fpara='RNNPARA.txt' #o̓t@C
try:
        os.remove(fpara) #t@C폜
except:
    print("t@C")
for i,dat in enumerate(model.params):
    dfile(fpara,'i',i)
    dfile(fpara,'params',dat)
print("PI")
